/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ColoniaDAO;
import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Colonia;
import com.rjconsultores.ventaboletos.service.ColoniaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

import org.springframework.stereotype.Service;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("coloniaService")
public class ColoniaServiceImpl implements ColoniaService {

    @Autowired
    private ColoniaDAO coloniaDAO;

    public List<Colonia> obtenerTodos() {
        return coloniaDAO.obtenerTodos();
    }

    public Colonia obtenerID(Integer id) {
        return coloniaDAO.obtenerID(id);
    }

    @Transactional
    public Colonia suscribir(Colonia entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return coloniaDAO.suscribir(entidad);
    }

    @Transactional
    public Colonia actualizacion(Colonia entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return coloniaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Colonia entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        coloniaDAO.actualizacion(entidad);
    }

    public List<Colonia> buscar(String desccolonia) {
         return coloniaDAO.buscar(desccolonia);
    }

    public List<Colonia> buscarPorCiudad(Ciudad ciudad) {
        return coloniaDAO.buscarPorCiudad(ciudad);
    }

	@Override
	public List<Colonia> buscaLike(String desccolonia) {
		return coloniaDAO.buscaLike(desccolonia);
	}

	@Override
	public List<Colonia> buscarPorCodMun(Ciudad ciudad, String desccolonia) {
		return coloniaDAO.buscarPorCodMun(ciudad, desccolonia);
	}
}
